#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<unistd.h>
#include<arpa/inet.h>
#include<sys/types.h>
#include<sys/socket.h>
#include "./error_handling.c"

#define BUFSIZE 30

int main(int argc,char **argv)
{
        int sock;
        pid_t pid;
        char message[BUFSIZE],nickmsg[BUFSIZE];
        int str_len, recv_len,recv_num;
        struct sockaddr_in serv_addr;

        if(argc!=4) { printf("Usage : %s <IP> <PORT> <nick>\n", argv[0]); exit(1); }

        sock=socket(PF_INET,SOCK_STREAM, 0 );

        memset(&serv_addr, 0 , sizeof(serv_addr));
        serv_addr.sin_family=AF_INET;
        serv_addr.sin_addr.s_addr=inet_addr(argv[1]);
        serv_addr.sin_port=htons(atoi(argv[2]));

        if(connect(sock, (struct sockaddr*)&serv_addr,sizeof(serv_addr))== -1)
                error_handling("Connect() Error!");

        pid=fork();
        if(pid==0){
                fputs("äմϴ  Ͻ÷ q",stdout);
                while(1){
                        fgets(message,BUFSIZE,stdin);
                        if(!strcmp(message,"q\n")) {
                                close(sock);
                                exit(0);
                        }
                sprintf(nickmsg,"[%s] : %s",argv[3],message);
                write(sock,nickmsg,strlen(nickmsg));
                }
        }
        else {
                while(1){
                        int str_len= read(sock,message,BUFSIZE);
                        if(str_len == 0) exit(0);
                        message[str_len]=0;
                        printf("  ۵ ޽ : %s\n",message);
                }
        }
        close(sock);
        return 0;
}
                         