#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<unistd.h>
#include<sys/types.h>
#include<sys/time.h>
#include<sys/socket.h>
#include<netinet/in.h>

#include "./error_handling.c"

#define BUFSIZE 100
#define MAX_NUM 20

int main(int argc, char **argv)
{
        int serv_sock,i=0;
        struct sockaddr_in serv_addr;

        fd_set reads,temps,serv_msg;
        int fd_max;

        char message[BUFSIZE];
        int str_len;
        struct timeval timeout;
        struct chating_memeber{
                int num[MAX_NUM];
                int cnn;
        }c_mem;
        c_mem.cnn=0;

        if(argc!=2){ printf("Use : %s <port>\n",argv[0]); exit(1); }

        serv_sock=socket(PF_INET,SOCK_STREAM,0);
        serv_addr.sin_family=AF_INET;
        serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
        serv_addr.sin_port=htons(atoi(argv[1]));

        if(bind(serv_sock, (struct sockaddr *)&serv_addr, sizeof(serv_addr)))
                error_handling("Bind() Error");
        if(listen(serv_sock, 5)==-1)
                error_handling("Listen() Error");

        FD_ZERO(&reads);
        FD_SET(serv_sock,&reads);
        fd_max = serv_sock;
        FD_ZERO(&serv_msg);
        FD_SET(0,&serv_msg);

        while(1){
                int fd,str_len;
                int clnt_sock,clnt_len;
                struct sockaddr_in clnt_addr;

                temps=reads;
                timeout.tv_sec=0;
                timeout.tv_usec=1000;


                if(select(fd_max+2,&temps,0,0,&timeout)==-1)
                        error_handling("Select() Error");
/*
                if(FD_ISSET(0,&serv_msg)){
                        fgets(message,BUFSIZE,stdin);
                        if(!strcmp(message,"q\n")){
                                if(c_mem.cnn==0) { printf(" ϰڽϴ"); exit(1); }
                                else { printf(" %d Ŭ̾Ʈ Դϴ\n",c_mem.cnn); }
                       }
                       if(!strcmp(message,"c\n")){ printf("  %dԴϴ.\n",c_mem.cnn); }
                }
*/
                for(fd=0;fd<fd_max+1;fd++){
                        if(fd==serv_sock){
                                clnt_len=sizeof(clnt_addr);
                                clnt_sock=accept(serv_sock,(struct sockaddr *)&clnt_addr,&clnt_len);
                                FD_SET(clnt_sock,&reads);
                                if(fd_max<clnt_sock) fd_max=clnt_sock;
                                printf("Client Connect : File Descriptor %d\n",clnt_sock);
                                c_mem.num[clnt_sock-3]=clnt_sock;
                                c_mem.cnn++;
                                printf("%d %d",c_mem.num[clnt_sock-3],c_mem.cnn);
                        }

                       else{
                                str_len=read(fd,message,BUFSIZE);
                                if(str_len==0){
                                        FD_CLR(fd,&reads);
                                        close(fd);
                                        printf("Client Close : File Descriptor %d\n",fd);
                                        c_mem.num[fd-3]=0;
                                        c_mem.cnn--;
                                        printf("%d %d",c_mem.num[clnt_sock-3],c_mem.cnn);

                                }
                                else{
                                      for(i=0;i<=MAX_NUM;i++){
                                              if(c_mem.num[i]>0) write(c_mem.num[i],message,str_len);
                                              else continue;
                                      }
//                                        write(fd,message,str_len);

                                }
                        }
                }
        }
}
